import 'dart:convert';
import 'package:flutter_conscent_plugin/ConscentInitializer.dart';
import 'package:flutter_conscent_plugin/shared_pref.dart';
import 'package:http/http.dart' as http;
import 'package:shared_preferences/shared_preferences.dart';
import 'Model/APIMode.dart';
import 'Model/content_access_model.dart';
import 'Model/logout.dart';
import 'Model/subscription_access_model.dart';

class ConscentMethods {
  ContentAccessModel? contentAccessModel;
  String? loginId;

  dynamic dataMain;
  Future<ContentAccessModel?> getLoginChallengeId() async {
    print('loginId ');
    final prefs = await SharedPreferences.getInstance();
    var loginId = prefs.getString('loginID');
    print('loginId $loginId');
    var responDtta = await getSessionID(loginId.toString());
    return responDtta;
    // setState(() {});
  }

  Future<ContentAccessModel?> getSessionID(String loginId) async {
    //  print('getSessionId------');
    var uri =
        Uri.parse('https://stage.tsbdev.co/api/v1/login-challenge/$loginId');
    print(uri);
    var response = await http.get(uri);
    if (response.statusCode == 200) {
      dataMain = jsonDecode(response.body);
      final prefs = await SharedPreferences.getInstance();
      print('dev sessionnnnnnnnnnnnn id');
      print(prefs.getString('sessionId'));
      String sessionId = dataMain['sessionId'].toString();
      prefs.setString('sessionId', sessionId);

      var responseDta = await submitDatas(
          ConscentInitializer.mClientId.toString(),
          ConscentInitializer.mContentId.toString(),
          sessionId);
      return responseDta;
    }
  }

  dynamic dataMains;
  Future<ContentAccessModel?> submitDatas(
    String clientId,
    String clientContentId,
    String sessionId,
  ) async {
    print('sessionId = $sessionId');
    var response = await http.post(
        Uri.parse('https://stage.tsbdev.co/api/v1/content/access'),
        body: {
          "clientId": clientId,
          "clientContentId": clientContentId,
          "sessionId": sessionId,
        });

    if (response.statusCode == 201) {
      dataMains = jsonDecode(response.body);
      var responseString = response.body;
      contentAccessModel = ContentAccessModel.fromJson(dataMains);
      //  print(dataMains);
      print(contentAccessModel!.signature);
      return contentAccessModel;
    }
  }

  Future<String?> getSessionIDs() async {
    var prefs = await SharedPreferences.getInstance();
    var isLogin = prefs.getString('loginID');
    return prefs.getString('sessionId');
  }

  Future<String?> isLogin() async {
    var prefs = await SharedPreferences.getInstance();
    var isLogin = prefs.getString('loginID');
    return isLogin;
  }

  // methods for subscription
  Future<Subscription_Access?> getLoginChallengeIdForSubs() async {
    final prefs = await SharedPreferences.getInstance();
    loginId = prefs.getString('loginID');
    print(loginId.toString());
    print('logindata');
    var responDtta = await getSessionIDForSubs(loginId.toString());
    // setState(() {});
    return responDtta;
  }

  Future<Subscription_Access?> getSessionIDForSubs(String loginId) async {
    //  print('getSessionId------');
    var uri = Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge/$loginId');
    print(uri);
    var response = await http.get(uri);
    if (response.statusCode == 200) {
      dataMain = jsonDecode(response.body);
      final prefs = await SharedPreferences.getInstance();
      //  print('dev sessionnnnnnnnnnnnn id');
      //    print(prefs.getString('sessionId'));
      String sessionId = dataMain['sessionId'].toString();
      prefs.setString('sessionId', sessionId);
      // print("dataMain");
      // print(dataMain);
      // print("dataMain");
      // CircularProgressIndicator();
      var responseDta = await getPstssForSubs();
      return responseDta;
      // submitDatas(clientId.text, clientContentId.text, sessionId);
      // Navigator.pop(context,{
      //   "sessionId":dataMain['sessionId']
      // });
    }
    //  return '';
  }

  Future<Subscription_Access?> getPstssForSubs() async {
    final prefs = await SharedPreferences.getInstance();
    var sessionId = prefs.getString('sessionId') ?? "sessionId";
    //   print('--------sessionidddddddddddddddd------------------');
    //   print(prefs.getString('sessionId'));
    var sessionIds = prefs.getString('sessionId');
    //   print('sessionId xyz= $sessionId');
    var uri = Uri.parse(
        '${APIMode.BASE_URL}api/v1/subscription/access?sessionId=$sessionIds'
        '&'
        'clientId=${ConscentInitializer.mClientId}');
    print(uri);
    print('sesiondataaaaaaaaa');
    var response = await http.get(uri);
    if (response.statusCode == 200) {
      dataMains = jsonDecode(response.body);
      print(dataMains);

      var responseString = response.body;
      // try {subscription_Access = Subscription_Access.fromJson(dataMains);}catch(e){print(e.toString());}
      var subscription_Access = Subscription_Access.fromJson(dataMains);
      print(dataMains);
      print(subscription_Access!.signature);
      print('datasub');
      return subscription_Access;
    }
    // Signatu signatureFromJson(responseString);
  }

  // logout
  dynamic dataMainlogout;
  Future<Logout> userLogOut(String sessionId) async {
    String? sessionId = await SharedPref().getSessionId();
    var response = await http.post(
        Uri.parse(
            '${APIMode.BASE_URL}api/v1/auth/logout-via-sessionid?sessionId=$sessionId'),
        body: {
          "sessionId": sessionId,
        });
    print(response.body);
    if (response.statusCode == 201) {
      dataMainlogout = jsonDecode(response.body);
      var responseString = response.body;
      return logoutFromJson(responseString);
    } else {
      throw Exception('Failed to create album.');
    }
  }

  //getUser()
  dynamic getusermain;

  Future<dynamic> getUser() async {
    print('getSessionId------');

    final prefs = await SharedPreferences.getInstance();
    String? sessionId = await SharedPref().getSessionId();
    sessionId = prefs.getString('sessionId');
    print(sessionId.toString());

    var uri = Uri.parse(
        '${APIMode.BASE_URL}api/v1/user/$sessionId?clientId=${ConscentInitializer.mClientId}');
    print(uri);
    var response = await http.get(uri);

    if (response.statusCode == 200) {
      getusermain = jsonDecode(response.body);
      // GetUserDetail getUserDetail = jsonDecode(response.body);
      print('getusermain  $getusermain');
      return getusermain;
    }
  }
}
